```wmd-options
language = es
title_i18n = wmarkdown_title_targets
title_text = Objetivos - WMarkDown
```

<!-- [[wmd]] -->

## Objetivos

Los objetivos para poder llevar a cabo este proyecto son los siguientes:

+ [X] Actualizar base del proyecto.
    + [X] Montar la aplicación AnP sobre Python y agregarlo a los servidores.
    + [X] Preparar el HTML para las páginas WMarkDown.
    + [X] Reestablecer el dominio local de pruebas contra AnP en vez de Apache.
+ [X] Montar estilos genéricos.
    + [X] Adjuntar el SASS de configuración y de elementos comunes de AnP.
    + [X] Establecer colores primarios y secundarios.
    + [X] Rehacer el logo del WMarkDown.
+ [-] CSS.
    + [X] Visualización general.
    + [X] Checkboxes y Radio Buttons.
    + [-] Visualización de los bloques de código.
    + [X] Estilos del menú dinámico.
+ [-] ECMAScript/JavaScript.
    + [ ] Gestión de la visuazalición de bloques de código y condición de bloques especiales.
    + [X] Crear menú dinámico sobre entorno cliente a partir de los ID de los Headers o títulos.
    + [X] Integrar los diccionarios del WDictionaries para unificar proyectos y actualizar formato.
        + [X] Formatear los archivos de diccionario JSON.
        + [X] Carga asíncrona de los diccionarios.
        + [X] Identificación de los elementos de los diccionarios en los textos al nivel establecido.
        + [X] Generar las cajas de muestreo de información del elemento de diccionario.
+ [-] Python.
    + [X] Crear base independiente para que pueda ser adjuntado en cualquier proyecto.
    + [X] Crear gestión de módulos dinámicos de forma simplificada sobre diccionarios y sistemas de Callbacks sobre patrones regulares.
    + [X] Crear módulo de análisis directo.
    + [X] Crear módulo de análisis vía bloque.
    + [X] Módulo para los párrafos.
    + [X] Módulo para los títulos y subtítulos.
    + [X] Módulo para las listas ordenadas y desordenadas.
    + [X] Módulo para la gestión de las tablas.
    + [X] Módulo para fragmentos de texto en negrita.
    + [X] Módulo para fragmentos de texto en itálica.
    + [X] Módulo para fragmentos de texto tachado.
    + [X] Módulo para fragmentos de texto subrayado.
    + [X] Módulo para fragmentos de texto monoespaciado o de código.
    + [X] Módulo para la visualización de Links.
        + [X] Links marcados.
        + [X] Links y Paths directos.
    + [X] Módulo para la visualización de imagen.
    + [-] Módulo para la visualización de vídeo.
        + [-] Vídeo nativo.
        + [ ] Vídeo de Youtube.
        + [ ] Vídeo de Vimeo.
    + [-] Módulo para la reproducción de audio.
        + [ ] Audio nativo.
        + [ ] Audio de Soundcloud.
    + [ ] Reproductor de múltiples audios.
    + [ ] Slider de imágenes y vídeos.
    + [-] Módulo de bloques de código.
        + [X] Implementar valores constantes y referencias en Python.
        + [ ] Implementar valores constantes y referencias en C#.
    + [-] Quotes o comentarios.
        + [X] Bloques crudos.
        + [X] Bloques iconificados.
        + [X] Bloques de comentario de usuario.
        + [ ] Bloques anidados.
    + [X] Inclusiones de archivos externos.
    + [X] Integrar el WDictionaries en el proyecto WMarkDown para unificar gestión documental.
    + [ ] Aplicar un sistema de tabulaciones adecuada para facilitar acceso al código fuente HTML.
    + [ ] Implementar sistema de comentarios para ignorar fragmentos de texto y que no salgan como resultado futuro.
    + [X] Implementar módulo de definición de método y/o función para documentación.
    + [X] Módulo para visualizar muestra de color.
    + [X] Módulo para visibilizar proyectos y recursos.
    + [ ] Módulo para visualizar direcciones de monedas o de pago mediante String y QR con Link integrado.
    + [ ] Módulo para comentar fragmentos que no resulten en el String de salida.
    + [ ] Implementar compatibilidad HTML.
        + [ ] Gestor de etiquetas HTML limitadas.
+ [X] Implementar SyntaxHightlighter para el módulo de bloque de código.
+ [X] Implementar MathJax.
+ [X] Implementar MermaidJS.
+ [ ] Implementar ejemplificación de uso del lenguaje WMarkDown "[[!wmd-examples]]".
+ [ ] Gestionar cacheados automáticos de los ficheros contra HTML para precompilaciones.

### Puntos del proyecto

Los puntos a cubrir dentro del proyecto son los siguientes:

[|
|= Objetivo              | Py  | C#  | Go  | PHP | JS  | CSS | HTML
|  Base HTML             |     |     |     |     | [X] | [X] | [X] 
|  Párrafos              | [X] | [X] | [ ] | [ ] |     | [X] |
|  Checkboxes            | [X] | [X] | [ ] | [ ] |     | [X] |
|  Radiobuttons          | [X] | [X] | [ ] | [ ] |     | [X] |
|  Ticks                 | [X] | [X] | [ ] | [ ] |     | [X] |
|  Títulos y cabeceras   | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Negrilla              | [X] | [X] | [ ] | [ ] |     | [X] |
|  Cursiva               | [X] | [X] | [ ] | [ ] |     | [X] |
|  Tachado               | [X] | [X] | [ ] | [ ] |     | [X] |
|  Subrayado             | [X] | [X] | [ ] | [ ] |     | [X] |
|  Links                 | [X] | [X] | [ ] | [ ] |     | [X] |
|  Muestras de color     | [X] | [X] | [ ] | [ ] |     | [X] |
|  Tablas                | [X] | [X] | [ ] | [ ] |     | [X] |
|  Listas                | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Quotes y comentarios  | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Bloques de código     | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Bloque MathJAX        | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Bloque Mermaid        | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Bloque de ejemplos    | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Bloque XML WMD        | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Links de presentación | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Módulo de exclusión   | [X] | [X] | [ ] | [ ] | [X] |     |
|  Inclusiones           | [X] | [X] | [ ] | [ ] |     |     |
|  Diccionario           |     |     |     |     | [X] | [X] |
|  Documento de código   | [X] | [X] | [ ] | [ ] | [X] | [X] |
|  Links Cryptomonedas   | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Scripts de ejemplo    | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Módulo de imagen      | [-] | [ ] | [ ] | [ ] | [-] | [-] |
|  Módulo de imágenes    | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Módulo de vídeo       | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Módulo de vídeos      | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Módulo de audio       | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Módulo de audios      | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Módulo de multimedia  | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Sistema de progreso   | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|  Bloque de comentarios | [ ] | [ ] | [ ] | [ ] | [ ] | [ ] |
|]

> [!#] Con respecto a Python y Go hablamos de compatibilidad local tanto servidor como WASM.

> [!#] Cuando hablamos de JS, en este caso, hablamos de un Script propio para la autogestión sobre el entorno local del navegador, pero no cara el desarrollo de esta tecnología cara este entorno, forzando el uso de WASM para dicho fin.

> [!#] CSS aquí incluye también SASS, siendo CSS para la iconificación y SASS para estilos. Sí es cierto que SASS admite la adjunción de caracteres Unicode escapados, sin embargo, para seguir la filosofía original de SASS, se separaron ambos conceptos.

> [!#] El diccionario es un proceso que se hace en caliente.

<!-- [[wmd]] -->