[[post_data {
    "author" : "KyMAN",
    "since" : 20210502,
    "version" : 20220402
}]]
# Objetivos

Aquí se incluirán los objetivos a realizar por los miembros del equipo, los Whalers, y se verán los
objetivos que aún faltan por alcanzar, así como todos aquellos objetivos alcanzados.

## Tarsier, KyMAN y angelus

Aquí ser pondrán dos columnas de Checkbox, las cuales indican, en el mismo orden en que está el
título de este apartado, los objetivos a cumplir, es decir, el primer Checkbox sería para Tarsier,
el segundo para KyMAN y el tercero a angelus.

- [ ] [X] [ ] Crear una cuenta GitHub.
    - [ ] [X] [ ] Publicar el proyecto.
    - [ ] [X] [ ] Poner el proyecto para ambos como desarrolladores.
- [ ] [ ] [ ] Crear página de Crowdfounding
    - [ ] [ ] [ ] Añadir las direcciones de Crowdfounding.

## Tarsier, KyMAN  y/o angelus

Aquí pasa un poco como en el anterior caso, la diferencia es que con tal de que uno de los dos halla
cumplido el objetivo llegaría para considerarlo completado.

- [ ] [X] [ ] Testear que todo esté correcto.
- [ ] [ ] [ ] Mirar el funcionamiento de los Crypto Core QT o conseguir direcciones para Crowdfounding.
- [-] [X] [ ] Colocar los logos de Tarsier.

## Tarsier

- [ ] Generar los estilos genéricos a partir de los estilos base que cree KyMAN.
- [-] Generar el logo del proyecto.
    - [ ] Vectorizarlo en entorno cuadrado (SVG).
    - [ ] Crear versión sólo negro y trasparente para fuente (SVG).
    - [ ] Crear versión a color 32x32 (PNG).
    - [ ] Crear versión a color 180x180 (PNG).
    - [ ] Crear versión a color 192x192 (PNG).
    - [ ] Crear versión a color 270x270 (PNG).
    - [ ] Crear versión a color 512x512 (PNG).
- [ ] Establecer gama de colores en la configuración del SCSS acordes con el logo.
    - *Cambiar colores/tonos del logo o del SCSS hasta que queden acordes e iguales.*
    - *Se pueden usar estrategias de contrarios y demás.*
- [ ] Montar los estilos responsitivos.
- [ ] Montar SEO.

## KyMAN

- [X] Renombrar todo el proyecto a WMarkDown.
- [X] Proponerle el sistema de Crowdfounding.
    - *por direcciones independientes según cada parte y por lo que quiera colaborar el donante.*
    - *Direcciones únicas y luego suministramos o dividimos.*
    - **Aprobado**.
- [X] Montar los estilos base.
    - [X] Implementar fuentes.
    - [X] Establecer los ficheros de SASS.
        - *Se incluye la configuración SCSS.*
    - [X] Iconificar.
    - [X] Dar formato final.
- [-] Montar los módulos:
    - [X] Cabeceras.
        - [X] Menú sobre cabeceras.
        - [X] Anidar cabeceras según nivel en el menú.
            - *No está anidado pero sí usa un sistema de niveles.*
        - [X] Ocultar y mostrar menús. Gestionar estilos.
    - [X] Párrafos.
    - [X] Formato de texto. *Solo negritas y cursivas.*
    - [X] Bloques de código o contenido plano.
        - [X] Identificar bloques de contenido plano.
        - [X] Implementar Syntax Highlighter.
        - [X] Implementar LaTeX, con seudónimo "Maths".
    - [X] Checkbox, Radio Buttons y Ticks.
    - [-] Listas.
        - [X] Gestionar anidamientos en HTML sobre UL y OL.
        - [ ] Añadir gráfica de evolución sobre una lista con Checks.
    - [X] Inclusión, implementación o importación de múltiples ficheros modo OnePage.
        - [X] Establecer vínculo Hash y de fichero.
    - [X] Quotes.
    - [X] Implementar parámetros.
    - [X] Links.
        - [X] Links normales.
        - [X] Links MarkDown.
        - [X] Links MediaWiki.
        - [X] Documentar.
    - [-] Multimedia.
        - *Los IFRAME no son gestionables desde CSS por CORS. Dependen de su contenedor.*
        - [X] Imágenes.
        - [X] Vídeos.
            - [X] Montar vídeos en *single* y *múltiple*.
            - [X] Montar gestión del MIME en PHP y JS.
                - [X] Montar gestión dinámica sin carga inicial de los MIME y las extensiones.
        - [X] Vídeos sobre plataformas embedadas.
            - [X] Youtube.
            - [X] Vimeo.
            - [X] Facebook.
                - *Da problemas con certificados autofirmados.*
            - [X] Twitch.
                - *Da problemas con certificados autofirmados.*
        - [X] Audios.
        - [X] Audios sobre plataformas embedadas.
            - [X] Soundcloud.
                - **No puede agregarse a partir de la URL.**
        - [ ] Sliders.
        - [X] Gestionar "NOSCRIPT" para SEO en los IFRAME.
        - [X] Cambiar punto de montaje de los Media a un Módulo completo independiente.
    - [-] Crear sistema de diccionarios para las páginas.
        - [X] Montar gestión de palabras sobre TextNodes.
        - [X] Gestionar ignorador de espacios.
        - [X] Gestionar GUI de búsqueda.
            - [X] Corregir Scroll.
        - [X] Aplicar resultados de patrones a los resultados.
        - [ ] Gestionar múltiples diccionarios.
            - *Inicialmente, pensando en anidaciones.*
    - [X] Montar Módulo de escapes.
- [X] Implementar.
    - [X] Sistema de gestión de diagramas.
        - *Elijo Mermaid contra JS, su versión original por ser un resultado HTML.*
    - [X] Syntax Highlighter.
        - *Elijo "highlighter.js", una librería ligera, abierta y gratuíta para JS en navegador.*
    - [X] Implementar intérprete de LaTeX.
- [ ] Montar el fichero JSON para gestión de eliminación de ficheros para actualizarlos.
    - [ ] Gestionar idiomas a partir de un elemento del Path.
    - [ ] Montar opción de "delete" para Git y así no montar ni JSON y HTML en Git.
        - *Sería opcional y para que no halla conflictos Merge en Git.*
- [ ] Cambiar de un sistema de diccionario a un sistema vectorial el parámetro de la configuración "default_modules".
    - *Se requiere por compatibilidad de orden con otros medios como Python.*
- [X] Montar textos para el HTML base.
- [X] Establecer sistema para los SEO Metas contra el HTML base.
- [ ] Añadir sistema de comentarios, Likes y visualizaciones.
    - [ ] Gestionar el SQLite.
    - [ ] Gestionar PHP.
        - [ ] Gestionar los procedimientos almacenados (Servicios).
        - [ ] Gestionar controladores.
        - [ ] Gestionar JS.
    - [ ] Gestión de visitas.
    - [ ] Gestión de usuarios.
    - [ ] Gestión de Likes.
    - [ ] Gestión de comentarios.
- [X] Documentar instalación del GitLab contra un Proxy Nginx externo.
- [X] Generar un archivo PHP Updater.
    - *Ha de Checkar nuevas versiones completas desde Git.*
    - *Ha de Checkar que si hay versiones nuevas para compilar la documentación.*
    - *Sistema diseñado a partir de la idea de __inoro__.*
- [ ] Añadir los ficheros de los componentes externos al CDN.
- [X] Externalizar en todos los proyectos que deriven de éste todos los parámetros de configuración a Secrets como Common.
    - *Esto permitirá compatibilizar proyectos locales con los de los servidores.*
    - *La idea es que solo halla que hacer "git pull" en los servidores.*
- [ ] Montar sistema de descarga en documento de la información en los siguientes formatos.
    - [ ] Texto plano.
    - [ ] WMarkDown.
    - [ ] HTML.
    - [ ] XML.
    - [ ] MySQL (MariaDB).
    - [ ] SQL Server.
    - [ ] SQLite.
    - [ ] DOC
    - [ ] ODT
    - [ ] PDF
- [ ] Documentar:
    - [ ] Secrets.
    - [ ] Implementación.
    - [ ] Creación de un complemento.
- [X] Montar Padding al contenido siguiendo la idea de inoro.
- [ ] Aplicar I18N contra entorno de variables PHP.
- [ ] Montar detector y cambiador de Versión Móvil.
- [ ] Montar responsitividad por rangos en el lado más estrecho.
- [ ] Montar modificador de tamaño de letra.
- [-] Montar el ScriptsAnalyzer.
    - [-] Montar el analizador de Scripts:
        - [X] PHP.
        - [X] JS/ECMA.
        - [ ] Python.
        - [ ] SQL (MariaDB, SQLite y SQL Server).
        - [-] C#.
    - [X] Montar Paths excluídos.
    - [X] Montar Paths incluídos.
- [X] Añadir Script automático para dar Status al logo (loading, error, ok).
- [X] Quitar el HTML resultante de la compilación del WMD y precompilar en el servidor.
    - *El objetivo es que se vea claramente, en el Git, el porcentaje de código real.*
- [X] Arreglar el Bug 20221012.
- [X] Agregar el Pusher.

## angelus

- [ ] Completar documentación haciendo de mano inocente.

[[html_data {
    "title" : "WMarkDown - Objetivos",
    "url" : "https://wmarkdown.k3y.pw/es/doc/targets.html",
    "author" : "Tarsier, KyMAN",
    "since" : 20210502,
    "version" : 20220402,
    "key_words" : "Whalers,MarkDown,MediaWiki,WMarkDown,objetivos",
    "description" : "Objetivos para llevar a cabo el proyecto.",
    "project" : "WMarkDown",
    "logo" : "https://wmarkdown.k3y.pw/images/wmarkdown.png",
    "language" : "es"
}]]
